#include <extdll.h>
#include <meta_api.h>
#include "plugin.h"
#include "vers_plugin.h"

//#include <sdk_util.h>		// REG_SVR_COMMAND, etc

#define COMPILE_TIME (const char *)(__DATE__ ", " __TIME__)

// Must provide at least one of these..
META_FUNCTIONS gMetaFunctionTable = {
	NULL,			// pfnGetEntityAPI			HL SDK;		called before game DLL
	NULL,			// pfnGetEntityAPI_Post			META;		called after game DLL
	GetEntityAPI2,		// pfnGetEntityAPI2			HL SDK2;	called before game DLL
	GetEntityAPI2_Post,	// pfnGetEntityAPI2_Post		META;		called after game DLL
	NULL,			// pfnGetNewDLLFunctions		HL SDK2;	called before game DLL
	NULL,			// pfnGetNewDLLFunctions_Post		META;		called after game DLL
	GetEngineFunctions,	// pfnGetEngineFunctions		META;		called before HL engine
	NULL,//GetEngineFunctions_Post,// pfnGetEngineFunctions_Post	META;		called after HL engine
};

cvar_t chatprotection_on	= {"scp_on","1", FCVAR_EXTDLL, 0, NULL};
cvar_t chatprotection_con	= {"scp_chat_on","1", FCVAR_EXTDLL, 0, NULL};
cvar_t chatprotection_son	= {"scp_spawn_on","1", FCVAR_EXTDLL, 0, NULL};
cvar_t chatprotection_hon	= {"scp_help_on","1", FCVAR_EXTDLL, 0, NULL};

cvar_t chatprotection_invi	= {"scp_transamt","75", FCVAR_EXTDLL, 0, NULL};
cvar_t chatprotection_canpickup	= {"scp_canpickup","1", FCVAR_EXTDLL, 0, NULL};

cvar_t chatprotection_offfire	= {"scp_off_onfire","1", FCVAR_EXTDLL, 0, NULL};
cvar_t chatprotection_offdelay	= {"scp_off_delay","5", FCVAR_EXTDLL, 0, NULL};
cvar_t chatprotection_offmsg	= {"scp_off_msg","Your protection has worn off!", FCVAR_EXTDLL, 0, NULL};

cvar_t chatprotection_sstayon	= {"scp_spawn_stayon","0", FCVAR_EXTDLL, 0, NULL};

cvar_t chatprotection_delay	= {"scp_chat_delay","5", FCVAR_EXTDLL, 0, NULL};
cvar_t chatprotection_ladder	= {"scp_chat_on_ladders","0", FCVAR_EXTDLL, 0, NULL};
cvar_t chatprotection_water	= {"scp_chat_in_water","1", FCVAR_EXTDLL, 0, NULL};
cvar_t chatprotection_msg	= {"scp_chat_msg","Protection has been enabled for you!", FCVAR_EXTDLL, 0, NULL};
cvar_t chatprotection_help	= {"scp_chat_help","If you want to get chat protection: face wall and don't move or shoot for %.1fsec.", FCVAR_EXTDLL, 0, NULL};

cvar_t chatprotection_ver 	= {"scp_version",VVERSION, FCVAR_EXTDLL|FCVAR_SERVER, 0, NULL};

extern cvar_t *scp_spawnstayon;
extern cvar_t *scp_help_on;
extern cvar_t *scp_on;
extern cvar_t *scp_con;
extern cvar_t *scp_son;
extern cvar_t *scp_msg;
extern cvar_t *scp_help;
extern cvar_t *scp_delay;
extern cvar_t *scp_onladder;
extern cvar_t *scp_inwater;

extern cvar_t *scp_off_onfire;
extern cvar_t *scp_offdelay;
extern cvar_t *scp_offmsg;
extern cvar_t *scp_transamt;
extern cvar_t *scp_canpickup;

// Plugin startup.  Register commands and cvars.
void plugin_init(void)
{
	LOG_MESSAGE(PLID, "%s v%s, %s", Plugin_info.name, Plugin_info.version, Plugin_info.date);
	LOG_MESSAGE(PLID, "by %s", Plugin_info.author);
	LOG_MESSAGE(PLID, "   %s", Plugin_info.url);
	LOG_MESSAGE(PLID, "compiled: %s EET", COMPILE_TIME);
	
	CVAR_REGISTER(&chatprotection_on);
	CVAR_REGISTER(&chatprotection_son);
	CVAR_REGISTER(&chatprotection_con);
	CVAR_REGISTER(&chatprotection_hon);
	
	CVAR_REGISTER(&chatprotection_canpickup);
	CVAR_REGISTER(&chatprotection_invi);
	
	CVAR_REGISTER(&chatprotection_offfire);
	
	CVAR_REGISTER(&chatprotection_offdelay);
	CVAR_REGISTER(&chatprotection_offmsg);
	
	CVAR_REGISTER(&chatprotection_sstayon);
	
	CVAR_REGISTER(&chatprotection_delay);
	CVAR_REGISTER(&chatprotection_ladder);
	CVAR_REGISTER(&chatprotection_water);
	CVAR_REGISTER(&chatprotection_msg);
	CVAR_REGISTER(&chatprotection_help);

	CVAR_REGISTER(&chatprotection_ver);
	
	scp_spawnstayon	= CVAR_GET_POINTER(chatprotection_sstayon.name);
	
	scp_on		= CVAR_GET_POINTER(chatprotection_on.name);
	scp_con		= CVAR_GET_POINTER(chatprotection_con.name);
	scp_son		= CVAR_GET_POINTER(chatprotection_son.name);
	scp_help_on	= CVAR_GET_POINTER(chatprotection_hon.name);
	
	scp_delay	= CVAR_GET_POINTER(chatprotection_delay.name);
	scp_msg		= CVAR_GET_POINTER(chatprotection_msg.name);
	scp_help	= CVAR_GET_POINTER(chatprotection_help.name);
	
	scp_offdelay	= CVAR_GET_POINTER(chatprotection_offdelay.name);
	scp_offmsg	= CVAR_GET_POINTER(chatprotection_offmsg.name);
	scp_transamt	= CVAR_GET_POINTER(chatprotection_invi.name);
	
	//scp_off_onpick	= CVAR_GET_POINTER(chatprotection_offpickup.name);
	scp_off_onfire	= CVAR_GET_POINTER(chatprotection_offfire.name);
	
	scp_canpickup	= CVAR_GET_POINTER(chatprotection_canpickup.name);
	scp_onladder	= CVAR_GET_POINTER(chatprotection_ladder.name);
	scp_inwater	= CVAR_GET_POINTER(chatprotection_water.name);
}

