#include <extdll.h>
#include "sdk_util.h"
#include "protection.h"
#include <dllapi.h>
#include <meta_api.h>
#include "userid_list.h"
#include "vers_plugin.h"
#include <entity_state.h>	//for updateclient

#ifdef __linux__
	#define strncmpi strncasecmp
#endif

cvar_t *scp_on;
cvar_t *scp_help_on;
cvar_t *scp_con;
cvar_t *scp_son;

cvar_t *scp_msg;
cvar_t *scp_help;
cvar_t *scp_delay;

cvar_t *scp_offdelay;
cvar_t *scp_offmsg;
cvar_t *scp_transamt;

cvar_t *scp_canpickup;

cvar_t *scp_onladder;
cvar_t *scp_inwater;
	//-
	// waterlevel 0 - not in water
	// waterlevel 1 - feet in water
	// waterlevel 2 - waist in water
	// waterlevel 3 - head in water
	//-
cvar_t *scp_spawnstayon;
cvar_t *scp_off_onfire;

player_t players[32];

#define fAnyButtonDown(button) (button & ~(IN_SCORE | IN_DUCK))	/* Allow IN_DUCK */

inline bool FPlayerAlive	(edict_t *pent)	{return (pent->v.health>0);}
inline bool FPlayerDead		(edict_t *pent)	{return (pent->v.health<=0);}
inline bool FPlayerAlive	(int id)	{return (players[id].old_health>0);}
inline bool FPlayerDead		(int id)	{return (players[id].old_health<=0);}

inline edict_t *UTIL_FindEntityByString( edict_t *pentStart, const char *szKeyword, const char *szValue )
{
   edict_t *pentEntity;

   pentEntity = FIND_ENTITY_BY_STRING( pentStart, szKeyword, szValue );

   if (!FNullEnt(pentEntity))
      return pentEntity;
   return NULL;
}

inline edict_t *UTIL_FindEntityByClassname( edict_t *pentStart, const char *szName )
{
   return UTIL_FindEntityByString( pentStart, "classname", szName );
}

inline void CheckGodOff(const int index,edict_t* &pThis);

void SetGodmodeOffForALL(void)
{
	for(int i=0;i<32;i++) if (players[i].UserID!=-1)
	{
		edict_t *pPlayer=NULL;
		bool found=false;
				
		for(int u=0;u<gpGlobals->maxClients;u++)
		{
			pPlayer=INDEXENT(u);
			int uid=GETPLAYERUSERID(pPlayer);
					
			if (uid!=-1 && uid==players[i].UserID && !FNullEnt(pPlayer))
			{
				found=true;
				break;
			}
		}
				
		if (found)
		{
			//players[i].IsInGodmode=true;
			CheckGodOff(i,pPlayer);
			players[i].prot_on=false;
		}
	}			
}

inline void Send_TextMsg(edict_t* &client, int msg_dest, const char *msg_name)
{
	int message_TextMsg = GET_USER_MSG_ID(PLID,"TextMsg",NULL);
	
	if (!message_TextMsg || client->v.flags & FL_FAKECLIENT) return;
	
	MESSAGE_BEGIN( MSG_ONE, message_TextMsg, NULL, client );
		WRITE_BYTE( msg_dest );
		WRITE_STRING( msg_name );
	MESSAGE_END();
}

inline void CheckGodOff(const int index,edict_t * &pThis)
{
	if (players[index].IsInGodmode) 
	{
		if (pThis)
		{
			pThis->v.solid 	   = SOLID_SLIDEBOX;
			pThis->v.takedamage= DAMAGE_AIM;
			pThis->v.rendermode= kRenderNormal;
			pThis->v.renderamt = 0;
		}
		
		players[index].IsInGodmode = false;
		
		char output[512];
		
		sprintf(output,"%s\n",scp_offmsg->string);
		Send_TextMsg(pThis,HUD_PRINTCENTER,output);
		
		//LOG MSG
		//LOG_MESSAGE(PLID,"Protection-Godmode disabled for player: '%s'\n",STRING(((edict_t *)*pThis)->v.netname));
	}
	
	return;
}

inline void CheckGodOn(const int index,edict_t* &pThis)
{
	if (!players[index].IsInGodmode) 
	{
		if (pThis)
		{
			int tamt=(int)scp_transamt->value;
			tamt=(tamt>=0)?((tamt<=255)?tamt:255):0;
			
			if(scp_canpickup->value==0)
				pThis->v.solid = SOLID_NOT;
				
			pThis->v.takedamage= DAMAGE_NO;
			pThis->v.rendermode= kRenderTransTexture;
			pThis->v.renderamt = tamt;
		}
		
		players[index].IsInGodmode = true;
		
		//LOG MSG
		//LOG_MESSAGE(PLID,"Protection-Godmode enabled for player: '%s'\n",STRING(((edict_t *)*pThis)->v.netname));
	}
	
	return;
}

inline int getlistid(edict_t* &pThis)
{
	int listid;
	int userid=listid=GETPLAYERUSERID(pThis);
	
	if (userid!=-1) 
	{
		listid = GetListIDByUserID( userid );
		if (listid==-1) 
			listid=AddToUserList( userid );
	}
	
	return listid;
}

bool CheckedAllOff=false;
inline bool CheckIfProtSetOff(void)
{
	if (scp_on->value==0)
	{
		if (!CheckedAllOff)
		{
			SetGodmodeOffForALL();
			CheckedAllOff=true;
		}
		
		return true;
		//RETURN_META(MRES_IGNORED);
	} 
	else 
	{
		if (CheckedAllOff) 
			CheckedAllOff=false;
	}
	
	return false;
}

inline bool PlayerLookingAtWall(edict_t *pMe)
{
	TraceResult tr;

	Vector WepPos=pMe->v.origin + pMe->v.view_ofs;

	MAKE_VECTORS(pMe->v.v_angle);
	TRACE_LINE (
		WepPos,					//Start
		WepPos + gpGlobals->v_forward * 128,	//End
		0x101,					//IgnoreMonsters and IgnoreGlass
		pMe,					//Ignore this ent
		&tr 					//output
	);
	
	if (tr.flFraction == 1.0) return false;

	float cosAngle = DotProduct(gpGlobals->v_forward,tr.vecPlaneNormal);
	
	if (cosAngle>-0.5f) return false;//60deg
	
	return true;
}

bool CheckIfHasFlag(edict_t * & pThis)
{
	edict_t *pent = NULL;
	//Check for Op4CTF
	while ((pent = UTIL_FindEntityByClassname( pent, "item_ctfflag" )) != NULL)
	{
		if (pent->v.owner == pThis)  // is this player carrying the item?
		{
			//Now check if flag's and owner's origins are same
			//If not flag has returned and not owned by anyone!
						
			return (pThis->v.origin == pent->v.origin);
		}
	}
	
	pent = NULL;
	//Check for TFC
	while ((pent = UTIL_FindEntityByClassname( pent, "item_tfgoal" )) != NULL)
	{
		if (pent->v.owner == pThis)  // is this player carrying the item?
		{
			//player has it .. return true
							
			return true;
		}
	}
	
	return false;
}

void PlayerThink( edict_t *pThis )
{
	if (	!gpGlobals->deathmatch		//Not multiplayer-server/game.
			||
		FNullEnt(pThis)			//Player isn't ok.
			||
		(pThis->v.spawnflags & SF_PLAYER_DISCONNECTED1 && pThis->v.spawnflags & SF_PLAYER_DISCONNECTED2)
						//Player has left server.
			||
		pThis->v.flags & FL_SPECTATOR	//Skip spectators
			||
		pThis->v.flags & FL_PROXY	//Skip spectator-proxy
	)
	{
		//Quit
		RETURN_META(MRES_IGNORED);
	}

	//Check if protection should be on.
	if (CheckIfProtSetOff()) RETURN_META(MRES_HANDLED);
	
	//Get listid
	int listid=getlistid(pThis);
	if (listid==-1) RETURN_META(MRES_IGNORED);

	//OP4CTF Spectator check .. if prot is off but takedamage is 0 we are in spectator mode!
	if (!players[listid].prot_on && pThis->v.takedamage==0)
		RETURN_META(MRES_IGNORED);
	
	//Op4CTF & TFC Flag Check
	if (gpGlobals->time>=players[listid].NextTimeToCheckFlag)
	{
		players[listid].HasFlag=CheckIfHasFlag(pThis);
		players[listid].NextTimeToCheckFlag=gpGlobals->time + 0.1f + RANDOM_FLOAT(0,0.1f);
	}
	
	//If has flag.. set prot off and exit
	if (players[listid].HasFlag)
	{
		if (players[listid].prot_on)
		{
			//Time to set prot off..
			CheckGodOff(listid,pThis);
			players[listid].prot_on=false;
		}
		
		RETURN_META(MRES_HANDLED);
	}

	if (players[listid].prot_on)
	{
		//Check if player has pressed any movement buttons
		if(fAnyButtonDown(pThis->v.button))
		{	//This is needed for chatp!
			players[listid].LastTimeWhenPressedButton=gpGlobals->time;
		}

		//Check if attacked.. and set prot off if off_on_fire set on (added 0.5sec extra off time for spawn (because usually players press fire when they want to respawn))
		if(	pThis->v.button & (IN_ATTACK | IN_ATTACK2) && scp_off_onfire->value!=0 
				&& 
			(	players[listid].prot_flags & FL_CHATPROT 
					|| 
				(players[listid].prot_flags & FL_SPAWNPROT && players[listid].StartOfProtection+0.5f<=gpGlobals->time)
			)
		  )
		{
			//Time to set sprot off..
			CheckGodOff(listid,pThis);
			players[listid].prot_on=false;
			
			//Make sure that ATTACK&ATTACK2 doesn't work (fix)
			pThis->v.button&=~(IN_ATTACK|IN_ATTACK2);
		}
	}
	else
	{
		//Check if player has pressed any movement buttons 
		//..check if is not looking at wall
		//..check if on ladders
		//..check if in water
		if(	fAnyButtonDown(pThis->v.button)						|| 
			!PlayerLookingAtWall(pThis)						|| 
			(scp_onladder->value == 0 && pThis->v.movetype   == MOVETYPE_FLY)	||
			(scp_inwater->value  == 0 && pThis->v.waterlevel >= 3))
		{	//This is needed for chatp!
			players[listid].LastTimeWhenPressedButton=gpGlobals->time;
		}
	}

	/*
	 *
	 *	Start of General Protection Code (Spawn protection)
	 *
	 */
	if (FPlayerDead(listid))	//Dude is dead .. check for respawn
	{
		if(FPlayerAlive(pThis))	//Player has respawned! .. start spawn-protection!
		{
			players[listid].LastTimeWhenPressedButton=gpGlobals->time;
			
			if (scp_son->value==0) 
			{
					//Set new health here
					players[listid].old_health=pThis->v.health;
				
					//Jump to ChatProtection
					goto Goto_StartOfChatProtection;
			}
			
			//Mark this protmode as spawn
			players[listid].prot_flags = FL_SPAWNPROT;
			
			//Set start of spawnprotection .. and set godmode on
			players[listid].StartOfProtection=gpGlobals->time;
			players[listid].prot_on=true;
			CheckGodOn(listid,pThis);
			
			if(scp_spawnstayon->value!=0)
			{
				//Make player keep protection if not moving
				players[listid].LastTimeWhenPressedButton=gpGlobals->time - scp_delay->value + 0.5f;
			}
			
			//Set new health here
			players[listid].old_health=pThis->v.health;
			
			//Make sure that ATTACK&ATTACK2 doesn't work
			pThis->v.button&=~(IN_ATTACK|IN_ATTACK2);
			
			//continue to chatprotection
		}
		else
		{
			//Still dead .. check godmode .. then exit
			CheckGodOff(listid,pThis);
			players[listid].prot_on=false;
			
			RETURN_META(MRES_IGNORED);
		}
	}
	else
	{
		//Was alive before .. check if is still alive!
		if(FPlayerAlive(pThis))
		{
			//yep .. player is alive.. check if we are in prot mode
			if (players[listid].prot_on)
			{
				//Check if we should set prot off
				if (players[listid].StartOfProtection+scp_offdelay->value<=gpGlobals->time)
				{
					//Time to set sprot off..
					CheckGodOff(listid,pThis);
					players[listid].prot_on=false;
					
					//Make sure that ATTACK&ATTACK2 doesn't work (fix)
					pThis->v.button&=~(IN_ATTACK|IN_ATTACK2);
				}
				else
				{
					//Make sure that ATTACK&ATTACK2 doesn't work
					pThis->v.button&=~(IN_ATTACK|IN_ATTACK2);
				}
			}
		}
		else
		{
			//was alive .. now dead
			CheckGodOff(listid,pThis);
			players[listid].prot_on=false;
			
			//Set new health here
			players[listid].old_health=pThis->v.health;
			
			RETURN_META(MRES_IGNORED);
		}
	}
	
Goto_StartOfChatProtection:
	/*
	 *	Start of chat protection
	 */
	if ((int)scp_con->value!=0 && players[listid].LastTimeWhenPressedButton+scp_delay->value<=gpGlobals->time)
	{
		//Time to start protection!
		
		//Show Message here (chatp enabled)
		if (!players[listid].prot_on)
		{
			//LOG MSG
			//LOG_MESSAGE(PLID,"Chat-Protection enabled for player: '%s'\n",STRING(pThis->v.netname));
			
			//
			char output[512];
			sprintf(output,"%s\n",scp_msg->string);
			Send_TextMsg(pThis,HUD_PRINTCENTER,output);
		}

		//Mark this protmode as chat
		players[listid].prot_flags = FL_CHATPROT;
		
		//Set start of chatprotection .. and set godmode on
		players[listid].StartOfProtection=gpGlobals->time;
		players[listid].prot_on=true;
		CheckGodOn(listid,pThis);
			
		//Make sure that ATTACK&ATTACK2 doesn't work
		pThis->v.button&=~(IN_ATTACK|IN_ATTACK2);
	}
	else
	{
		//Do nothing
	}
	
	RETURN_META(MRES_HANDLED);
}

void ClientDisconnect( edict_t *pThis )
{
	if (!gpGlobals->deathmatch) RETURN_META(MRES_IGNORED);
	
	int listid;
	int userid=GETPLAYERUSERID(pThis);
	
	if (userid==-1) RETURN_META(MRES_IGNORED);
	
	listid = GetListIDByUserID( userid );
	
	if (listid==-1) RETURN_META(MRES_IGNORED);
	
	//printf("Removed slot%d .. ok!\n",listid);
	
	//HACK HACK! We have to set this on so UserID doesn't get add to list after disconnect!
	pThis->v.spawnflags|=(SF_PLAYER_DISCONNECTED1|SF_PLAYER_DISCONNECTED2);
	
	memset(&players[listid],0,sizeof(player_t));
	
	players[listid].NextTimeToCheckFlag			=
		players[listid].LastTimeWhenPressedButton	=
		players[listid].StartOfProtection		=	gpGlobals->time;
	
	players[listid].IsInGodmode	=
		players[listid].prot_on	=	players[listid].HasFlag=false;
		
	players[listid].old_health	=
		players[listid].UserID	=	-1;
		
	players[listid].prot_flags = 0;
	
	RETURN_META(MRES_HANDLED);
}

int DispatchSpawn( edict_t *pent )
{	
	if (!gpGlobals->deathmatch)
	{
		RETURN_META_VALUE(MRES_IGNORED,	0);
		return 1337;
	}
	
	char *pClassname = (char *)STRING(pent->v.classname);

	if (!stricmp(pClassname, "worldspawn"))
	{
		//Reset PlayerList
		memset(&players,0,sizeof(players));
		
		for (byte i=0;i<32;i++)
		{
			players[i].NextTimeToCheckFlag			=
				players[i].LastTimeWhenPressedButton	=
				players[i].StartOfProtection		=	gpGlobals->time;
				
			players[i].IsInGodmode		=
				players[i].prot_on	=	players[i].HasFlag=false;
				
			players[i].old_health		=
				players[i].UserID	=	-1;
				
			players[i].prot_flags = 0;
		}
	}

	RETURN_META_VALUE(MRES_HANDLED,	0);
	return 1337; //Fixes Borland C++ error msg: Function must return value .. 'return value' is done already in RETURN_META_VALUE
}

/*
 *	OP4CTF/TFC Teamplay fix (and class)
 *
 *
 */
static bool Processing_in_Clientcommand=false;
static int _ccmd_listid;
void ClientCommand( edict_t *pThis )
{
	if (	!gpGlobals->deathmatch		//Not multiplayer-server/game.
			||
		scp_on->value==0
			||
		FNullEnt(pThis)			//Player isn't ok.
			||
		(pThis->v.spawnflags & SF_PLAYER_DISCONNECTED1 && pThis->v.spawnflags & SF_PLAYER_DISCONNECTED2))
						//Player has left server.
	{
		//Quit
		RETURN_META(MRES_IGNORED);
	}
	
	const char *pcmd = CMD_ARGV(0);
	//ALERT(at_console,"CC: '%s' '%s'\n",pcmd,CMD_ARGS());
	//printf("CC: '%s' '%s'\n",pcmd,CMD_ARGS());
	
	if (!stricmp(pcmd,"spectate"))			//OP4CTF switch to spectator-mode
	{
		//Get listid
		int listid=getlistid(pThis);
		if (listid==-1) RETURN_META(MRES_IGNORED);
		
		//Set Godmode off!
		CheckGodOff(listid,pThis);
		players[listid].prot_on=false;
		
		//Set negative health so that spawn works after spectating
		players[listid].old_health=-1337;
		
		RETURN_META(MRES_HANDLED);
	}
	else if (!stricmp(pcmd,"selectchar"))		//OP4CTF-Team change
	{
		//Get listid
		_ccmd_listid=getlistid(pThis);
		if (_ccmd_listid==-1) RETURN_META(MRES_IGNORED);
	
		//Let's set protection off
		if (players[_ccmd_listid].prot_on)
		{
			pThis->v.solid		= SOLID_SLIDEBOX;
			pThis->v.takedamage	= DAMAGE_AIM;
			pThis->v.rendermode	= kRenderNormal;
			pThis->v.renderamt	= 0;
		}
	
		Processing_in_Clientcommand=true;
	
		RETURN_META(MRES_HANDLED);
	}
	
	RETURN_META(MRES_IGNORED);
}

void ClientCommand_Post( edict_t *pThis )
{
	if (Processing_in_Clientcommand)
	{
		//Set protection back!
		if (players[_ccmd_listid].prot_on)
		{
			int tamt=(int)scp_transamt->value;
			tamt=(tamt>=0)?((tamt<=255)?tamt:255):0;
			
			if(scp_canpickup->value==0)
				pThis->v.solid = SOLID_NOT;
				
			pThis->v.takedamage= DAMAGE_NO;
			pThis->v.rendermode= kRenderTransTexture;
			pThis->v.renderamt = tamt;
		}
	
		Processing_in_Clientcommand=false;
		_ccmd_listid=-1;
	}
	
	if ((!gpGlobals->deathmatch) || scp_on->value==0 || scp_help_on->value==0 || CMD_ARGC() < 2 )
		RETURN_META(MRES_IGNORED);
	
	const char *pcmd  = CMD_ARGV(0);
	const char *saycmd= CMD_ARGV(1);
	
	if (!stricmp(pcmd,"say") || !stricmp(pcmd,"say_team"))
	{
		if (	!strncmpi(saycmd,"chat",4)
				||
			!strncmpi(saycmd,"prot",4))
		{
			char output[512];
			char format[256];
			
			sprintf(format,"["VLOGTAG"] %s\n",scp_help->string);
			format[255]=0;
			
			sprintf(output,format,scp_delay->value);
			output[511]=0;

			edict_t *client = NULL;
			while ( ((client = UTIL_FindEntityByClassname( client, "player" )) != NULL)) 
			{
				if (FNullEnt(client))
					continue;
					
				Send_TextMsg(client,HUD_PRINTTALK,output);
			}
		}
	}
	
	RETURN_META(MRES_HANDLED);
}

/*
 *	To make hldm 1.1.0.8 work right way!
 *
 *		and TFC and opfor 1.1.0.8 (and CS)
 */
void UpdateClientData_Post(const struct edict_s *ent, int sendweapons, struct clientdata_s *cd)
{
	edict_t *pThis=(edict_t*)ent;
	
	if (	!gpGlobals->deathmatch		//Not multiplayer-server/game.
			||
		scp_on->value==0
			||
		FNullEnt(pThis)			//Player isn't ok.
			||
		(pThis->v.spawnflags & SF_PLAYER_DISCONNECTED1 && pThis->v.spawnflags & SF_PLAYER_DISCONNECTED2))
						//Player has left server.
	{
		//Quit
		RETURN_META(MRES_IGNORED);
	}

	//Get listid
	int listid=getlistid(pThis);
	if (listid==-1) RETURN_META(MRES_IGNORED);
	
	if (sendweapons && players[listid].prot_on)
	{
		//ALERT(at_console,"Sendweapons and Prot_on!\n");
		if (cd->m_flNextAttack < gpGlobals->time)
			cd->m_flNextAttack = (players[listid].StartOfProtection + scp_offdelay->value) - (gpGlobals->time + 0.001f);
		else
			cd->m_flNextAttack = (players[listid].StartOfProtection + scp_offdelay->value) - 0.001f;
	}
	
	RETURN_META(MRES_HANDLED);
}

/*
 *	HLDM/OP4-Teamplay fix!
 *
 *		Sets protection off for time of ClientUserInfoChange.
 *
 *	Call order (metamod) is always this:
 *
 *		SCPlugin-CUIChanged -> GameDLL-CUIChanged -> SCPlugin-CUIChanged_Post
 *
 */
static bool Processing_in_Userinfo=false;
static int _cuic_listid;
void ClientUserInfoChanged(edict_t *pThis, char *infobuffer)
{
	if (	!gpGlobals->deathmatch		//Not multiplayer-server/game.
			||
		scp_on->value==0
			||
		FNullEnt(pThis)			//Player isn't ok.
			||
		(pThis->v.spawnflags & SF_PLAYER_DISCONNECTED1 && pThis->v.spawnflags & SF_PLAYER_DISCONNECTED2))
						//Player has left server.
	{
		//Quit
		RETURN_META(MRES_IGNORED);
	}
	
	//Get listid
	_cuic_listid=getlistid(pThis);
	if (_cuic_listid==-1) RETURN_META(MRES_IGNORED);
	
	//Let's set protection off
	if (players[_cuic_listid].prot_on)
	{
		pThis->v.solid		= SOLID_SLIDEBOX;
		pThis->v.takedamage	= DAMAGE_AIM;
		pThis->v.rendermode	= kRenderNormal;
		pThis->v.renderamt	= 0;
	}
	
	Processing_in_Userinfo=true;
	
	RETURN_META(MRES_HANDLED);
}

void ClientUserInfoChanged_Post(edict_t *pThis, char *infobuffer)
{
	if (!Processing_in_Userinfo)
	{
		//Quit
		RETURN_META(MRES_IGNORED);
	}
	
	//Set protection back!
	if (players[_cuic_listid].prot_on)
	{
		int tamt=(int)scp_transamt->value;
		tamt=(tamt>=0)?((tamt<=255)?tamt:255):0;
			
		if(scp_canpickup->value==0)
			pThis->v.solid = SOLID_NOT;
				
		pThis->v.takedamage= DAMAGE_NO;
		pThis->v.rendermode= kRenderTransTexture;
		pThis->v.renderamt = tamt;
	}
	
	Processing_in_Userinfo=false;
	_cuic_listid=-1;
	
	RETURN_META(MRES_HANDLED);
}

/*
 *	trigger_hurt fix!
 *		without this player could go throught force-fields and/or drop in to pits without getting killed
 *
 */
static bool Processing_in_DispatchTouch=false;
static int _dt_listid;
void DispatchTouch( edict_t *pentTouched, edict_t *pThis )
{
	if (	!gpGlobals->deathmatch		//Not multiplayer-server/game.
			||
		scp_on->value==0)
	{
		//Quit
		RETURN_META(MRES_IGNORED);
	}

	//Only if touched with trigger_hurt
	if (	!pentTouched
			||
		!pentTouched->v.classname 
			||
		!((STRING(pentTouched->v.classname))[0]=='t')
			||
		stricmp((STRING(pentTouched->v.classname)+1),"rigger_hurt"))
	{
		//Quit
		RETURN_META(MRES_IGNORED);
	}
	
	if (	FNullEnt(pThis)			//Player isn't ok.
			||
		!pThis->v.netname
			||
		!(STRING(pThis->v.netname))[0]
			||
		(pThis->v.spawnflags & SF_PLAYER_DISCONNECTED1 && pThis->v.spawnflags & SF_PLAYER_DISCONNECTED2))
						//Player has left server.
	{
		//Quit
		RETURN_META(MRES_IGNORED);
	}
	
	//Get listid
	_dt_listid=getlistid(pThis);
	if (_dt_listid==-1) RETURN_META(MRES_IGNORED);
	
	//Let's set protection off
	if (players[_dt_listid].prot_on)
	{
		pThis->v.solid		= SOLID_SLIDEBOX;
		pThis->v.takedamage	= DAMAGE_AIM;
		pThis->v.rendermode	= kRenderNormal;
		pThis->v.renderamt	= 0;
	}
	
	Processing_in_DispatchTouch=true;
	
	RETURN_META(MRES_HANDLED);
}

void DispatchTouch_Post( edict_t *pentTouched, edict_t *pThis )
{
	if (!Processing_in_DispatchTouch)
	{
		//Quit
		RETURN_META(MRES_IGNORED);
	}
	
	//Set protection back!
	if (players[_dt_listid].prot_on)
	{
		int tamt=(int)scp_transamt->value;
		tamt=(tamt>=0)?((tamt<=255)?tamt:255):0;
			
		if(scp_canpickup->value==0)
			pThis->v.solid = SOLID_NOT;
				
		pThis->v.takedamage= DAMAGE_NO;
		pThis->v.rendermode= kRenderTransTexture;
		pThis->v.renderamt = tamt;
	}
	
	Processing_in_DispatchTouch=false;
	_dt_listid=-1;
	
	RETURN_META(MRES_HANDLED);
}

edict_t* FindEntityByString(edict_t *pEdictStartSearchAfter, const char *pszField, const char *pszValue)
{
	// if a new round has started, tell the bots this...
	if (strcmp(pszValue, "info_map_parameters") != 0) RETURN_META_VALUE(MRES_IGNORED, NULL);


	for(int listid=0;listid<32;listid++)
	{
		players[listid].NextTimeToCheckFlag		=
		players[listid].LastTimeWhenPressedButton	=
		players[listid].StartOfProtection		=	gpGlobals->time;
	
		players[listid].IsInGodmode	=
		players[listid].prot_on		=	
		players[listid].HasFlag		= false;

		players[listid].prot_flags	= 0;
	
		players[listid].old_health	= -1;
	}
	
	
	RETURN_META_VALUE(MRES_IGNORED, NULL);
	return NULL;
}

static DLL_FUNCTIONS gFunctionTable =
{
	NULL,						//! pfnGameInit()
	DispatchSpawn,					//! pfnSpawn()
	NULL,						//! pfnThink()
	NULL,						//! pfnUse()
	DispatchTouch,					//! pfnTouch()
	NULL,						//! pfnBlocked()
	NULL,						//! pfnKeyValue()
	NULL,						//! pfnSave()
	NULL,						//! pfnRestore()
	NULL,						//! pfnSetAbsBox()

	NULL,						//! pfnSaveWriteFields()
	NULL,						//! pfnSaveReadFields()

	NULL,						//! pfnSaveGlobalState()
	NULL,						//! pfnRestoreGlobalState()
	NULL,						//! pfnResetGlobalState()

	NULL,						//! pfnClientConnect()
	ClientDisconnect,				//! pfnClientDisconnect()
	NULL,						//! pfnClientKill()
	NULL,						//! pfnClientPutInServer()
	ClientCommand,					//! pfnClientCommand()
	ClientUserInfoChanged,				//! pfnClientUserInfoChanged()
	NULL,						//! pfnServerActivate()
	NULL,						//! pfnServerDeactivate()

	NULL,						//! pfnPlayerPreThink()
	PlayerThink,					//! pfnPlayerPostThink()

	NULL,						//! pfnStartFrame()
	NULL,						//! pfnParmsNewLevel()
	NULL,						//! pfnParmsChangeLevel()

	NULL,						//! pfnGetGameDescription()
	NULL,						//! pfnPlayerCustomization()

	NULL,						//! pfnSpectatorConnect()
	NULL,						//! pfnSpectatorDisconnect()
	NULL,						//! pfnSpectatorThink()

	NULL,						//! pfnSys_Error()

	NULL,						//! pfnPM_Move()
	NULL,						//! pfnPM_Init()
	NULL,						//! pfnPM_FindTextureType()

	NULL,						//! pfnSetupVisibility()
	NULL,						//! pfnUpdateClientData()
	NULL,						//! pfnAddToFullPack()
	NULL,						//! pfnCreateBaseline()
	NULL,						//! pfnRegisterEncoders()
	NULL,						//! pfnGetWeaponData()
	NULL,						//! pfnCmdStart()
	NULL,						//! pfnCmdEnd()
	NULL,						//! pfnConnectionlessPacket()
	NULL,						//! pfnGetHullBounds()
	NULL,						//! pfnCreateInstancedBaselines()
	NULL,						//! pfnInconsistentFile()
	NULL,						//! pfnAllowLagCompensation()
};

C_DLLEXPORT int	GetEntityAPI2( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion )
{
	LOG_DEVELOPER(PLID, "called: GetEntityAPI2; version=%d", *interfaceVersion);
	if(!pFunctionTable) {
		LOG_ERROR(PLID,	"GetEntityAPI2 called with null	pFunctionTable");
		return(FALSE);
	}
	else if(*interfaceVersion != INTERFACE_VERSION)	{
		LOG_ERROR(PLID,	"GetEntityAPI2 version mismatch; requested=%d ours=%d",	*interfaceVersion, INTERFACE_VERSION);
		//! Tell engine	what version we	had, so	it can figure out who is out of	date.
		*interfaceVersion = INTERFACE_VERSION;
		return(FALSE);
	}
	memcpy(pFunctionTable, &gFunctionTable,	sizeof(DLL_FUNCTIONS));
	return(TRUE);
}

static DLL_FUNCTIONS gFunctionTable_Post =
{
	NULL,						//! pfnGameInit()
	NULL,						//! pfnSpawn()
	NULL,						//! pfnThink()
	NULL,						//! pfnUse()
	DispatchTouch_Post,				//! pfnTouch()
	NULL,						//! pfnBlocked()
	NULL,						//! pfnKeyValue()
	NULL,						//! pfnSave()
	NULL,						//! pfnRestore()
	NULL,						//! pfnSetAbsBox()

	NULL,						//! pfnSaveWriteFields()
	NULL,						//! pfnSaveReadFields()

	NULL,						//! pfnSaveGlobalState()
	NULL,						//! pfnRestoreGlobalState()
	NULL,						//! pfnResetGlobalState()

	NULL,						//! pfnClientConnect()
	NULL,						//! pfnClientDisconnect()
	NULL,						//! pfnClientKill()
	NULL,						//! pfnClientPutInServer()
	ClientCommand_Post,				//! pfnClientCommand()
	ClientUserInfoChanged_Post,			//! pfnClientUserInfoChanged()
	NULL,						//! pfnServerActivate()
	NULL,						//! pfnServerDeactivate()

	NULL,						//! pfnPlayerPreThink()
	NULL,						//! pfnPlayerPostThink()

	NULL,						//! pfnStartFrame()
	NULL,						//! pfnParmsNewLevel()
	NULL,						//! pfnParmsChangeLevel()

	NULL,						//! pfnGetGameDescription()
	NULL,						//! pfnPlayerCustomization()

	NULL,						//! pfnSpectatorConnect()
	NULL,						//! pfnSpectatorDisconnect()
	NULL,						//! pfnSpectatorThink()

	NULL,						//! pfnSys_Error()

	NULL,						//! pfnPM_Move()
	NULL,						//! pfnPM_Init()
	NULL,						//! pfnPM_FindTextureType()

	NULL,						//! pfnSetupVisibility()
	UpdateClientData_Post,				//! pfnUpdateClientData()
	NULL,						//! pfnAddToFullPack()
	NULL,						//! pfnCreateBaseline()
	NULL,						//! pfnRegisterEncoders()
	NULL,						//! pfnGetWeaponData()
	NULL,						//! pfnCmdStart()
	NULL,						//! pfnCmdEnd()
	NULL,						//! pfnConnectionlessPacket()
	NULL,						//! pfnGetHullBounds()
	NULL,						//! pfnCreateInstancedBaselines()
	NULL,						//! pfnInconsistentFile()
	NULL,						//! pfnAllowLagCompensation()
};

C_DLLEXPORT int GetEntityAPI2_Post( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion )
{
	LOG_DEVELOPER(PLID, "called: GetEntityAPI2_Post; version=%d", *interfaceVersion);
	if(!pFunctionTable) {
		LOG_ERROR(PLID, "GetEntityAPI2_Post called with null pFunctionTable");
		return(FALSE);
	}
	else if(*interfaceVersion != INTERFACE_VERSION) {
		LOG_ERROR(PLID, "GetEntityAPI2_Post version mismatch; requested=%d ours=%d", *interfaceVersion, INTERFACE_VERSION);
		//! Tell engine what version we had, so it can figure out who is out of date.
		*interfaceVersion = INTERFACE_VERSION;
		return(FALSE);
	}
	memcpy( pFunctionTable, &gFunctionTable_Post, sizeof( DLL_FUNCTIONS ) );
	return(TRUE);
}

enginefuncs_t meta_engfuncs = {
	NULL,			// pfnPrecacheModel()
	NULL,			// pfnPrecacheSound()
	NULL,			// pfnSetModel()
	NULL,			// pfnModelIndex()
	NULL,			// pfnModelFrames()

	NULL,			// pfnSetSize()
	NULL,			// pfnChangeLevel()
	NULL,			// pfnGetSpawnParms()
	NULL,			// pfnSaveSpawnParms()

	NULL,			// pfnVecToYaw()
	NULL,			// pfnVecToAngles()
	NULL,			// pfnMoveToOrigin()
	NULL,			// pfnChangeYaw()
	NULL,			// pfnChangePitch()

	FindEntityByString,	// pfnFindEntityByString()
	NULL,			// pfnGetEntityIllum()
	NULL,			// pfnFindEntityInSphere()
	NULL,			// pfnFindClientInPVS()
	NULL,			// pfnEntitiesInPVS()

	NULL,			// pfnMakeVectors()
	NULL,			// pfnAngleVectors()

	NULL,			// pfnCreateEntity()
	NULL,			// pfnRemoveEntity()
	NULL,			// pfnCreateNamedEntity()

	NULL,			// pfnMakeStatic()
	NULL,			// pfnEntIsOnFloor()
	NULL,			// pfnDropToFloor()

	NULL,			// pfnWalkMove()
	NULL,			// pfnSetOrigin()

	NULL,			// pfnEmitSound()
	NULL,			// pfnEmitAmbientSound()

	NULL,			// pfnTraceLine()
	NULL,			// pfnTraceToss()
	NULL,			// pfnTraceMonsterHull()
	NULL,			// pfnTraceHull()
	NULL,			// pfnTraceModel()
	NULL,			// pfnTraceTexture()
	NULL,			// pfnTraceSphere()
	NULL,			// pfnGetAimVector()

	NULL,			// pfnServerCommand()
	NULL,			// pfnServerExecute()
	NULL,			// pfnClientCommand()

	NULL,			// pfnParticleEffect()
	NULL,			// pfnLightStyle()
	NULL,			// pfnDecalIndex()
	NULL,			// pfnPointContents()

	NULL,			// pfnMessageBegin()
	NULL,			// pfnMessageEnd()

	NULL,			// pfnWriteByte()
	NULL,			// pfnWriteChar()
	NULL,			// pfnWriteShort()
	NULL,			// pfnWriteLong()
	NULL,			// pfnWriteAngle()
	NULL,			// pfnWriteCoord()
	NULL,			// pfnWriteString()
	NULL,			// pfnWriteEntity()

	NULL,			// pfnCVarRegister()
	NULL,			// pfnCVarGetFloat()
	NULL,			// pfnCVarGetString()
	NULL,			// pfnCVarSetFloat()
	NULL,			// pfnCVarSetString()

	NULL,			// pfnAlertMessage()
	NULL,			// pfnEngineFprintf()

	NULL,			// pfnPvAllocEntPrivateData()
	NULL,			// pfnPvEntPrivateData()
	NULL,			// pfnFreeEntPrivateData()

	NULL,			// pfnSzFromIndex()
	NULL,			// pfnAllocString()

	NULL, 			// pfnGetVarsOfEnt()
	NULL,			// pfnPEntityOfEntOffset()
	NULL,			// pfnEntOffsetOfPEntity()
	NULL,			// pfnIndexOfEdict()
	NULL,			// pfnPEntityOfEntIndex()
	NULL,			// pfnFindEntityByVars()
	NULL,			// pfnGetModelPtr()

	NULL,			// pfnRegUserMsg()

	NULL,			// pfnAnimationAutomove()
	NULL,			// pfnGetBonePosition()

	NULL,			// pfnFunctionFromName()
	NULL,			// pfnNameForFunction()

	NULL,			// pfnClientPrintf()			//! JOHN: engine callbacks so game DLL can print messages to individual clients
	NULL,			// pfnServerPrint()

	NULL,			// pfnCmd_Args()	//! these 3 added 
	NULL,			// pfnCmd_Argv()	//! so game DLL can easily 
	NULL,			// pfnCmd_Argc()	//! access client 'cmd' strings

	NULL,			// pfnGetAttachment()

	NULL,			// pfnCRC32_Init()
	NULL,			// pfnCRC32_ProcessBuffer()
	NULL,			// pfnCRC32_ProcessByte()
	NULL,			// pfnCRC32_Final()

	NULL,			// pfnRandomLong()
	NULL,			// pfnRandomFloat()

	NULL,			// pfnSetView()
	NULL,			// pfnTime()
	NULL,			// pfnCrosshairAngle()

	NULL,			// pfnLoadFileForMe()
	NULL,			// pfnFreeFile()

	NULL,			// pfnEndSection()				//! trigger_endsection
	NULL,			// pfnCompareFileTime()
	NULL,			// pfnGetGameDir()
	NULL,			// pfnCvar_RegisterVariable()
	NULL,			// pfnFadeClientVolume()
	NULL,			// pfnSetClientMaxspeed()
	NULL,			// pfnCreateFakeClient() 		//! returns NULL if fake client can't be created
	NULL,			// pfnRunPlayerMove()
	NULL,			// pfnNumberOfEntities()

	NULL,			// pfnGetInfoKeyBuffer()		//! passing in NULL gets the serverinfo
	NULL,			// pfnInfoKeyValue()
	NULL,			// pfnSetKeyValue()
	NULL,			// pfnSetClientKeyValue()
	
	NULL,			// pfnIsMapValid()
	NULL,			// pfnStaticDecal()
	NULL,			// pfnPrecacheGeneric()
	NULL,			// pfnGetPlayerUserId()			//! returns the server assigned userid for this player.
	NULL,			// pfnBuildSoundMsg()
	NULL,			// pfnIsDedicatedServer()		//! is this a dedicated server?
	NULL,			// pfnCVarGetPointer()
	NULL,			// pfnGetPlayerWONId()			//! returns the server assigned WONid for this player.

	//! YWB 8/1/99 TFF Physics additions
	NULL,			// pfnInfo_RemoveKey()
	NULL,			// pfnGetPhysicsKeyValue()
	NULL,			// pfnSetPhysicsKeyValue()
	NULL,			// pfnGetPhysicsInfoString()
	NULL,			// pfnPrecacheEvent()
	NULL,			// pfnPlaybackEvent()

	NULL,			// pfnSetFatPVS()
	NULL,			// pfnSetFatPAS()

	NULL,			// pfnCheckVisibility()

	NULL,			// pfnDeltaSetField()
	NULL,			// pfnDeltaUnsetField()
	NULL,			// pfnDeltaAddEncoder()
	NULL,			// pfnGetCurrentPlayer()
	NULL,			// pfnCanSkipPlayer()
	NULL,			// pfnDeltaFindField()
	NULL,			// pfnDeltaSetFieldByIndex()
	NULL,			// pfnDeltaUnsetFieldByIndex()

	NULL,			// pfnSetGroupMask()

	NULL,			// pfnCreateInstancedBaseline()		// d'oh, CreateInstancedBaseline in dllapi too
	NULL,			// pfnCvar_DirectSet()

	NULL,			// pfnForceUnmodified()

	NULL,			// pfnGetPlayerStats()

	NULL,			// pfnAddServerCommand()
};

C_DLLEXPORT int GetEngineFunctions(enginefuncs_t *pengfuncsFromEngine, int *interfaceVersion ) 
{
	if(!pengfuncsFromEngine) {
		UTIL_LogPrintf("%s: GetEngineFunctions called with null pengfuncsFromEngine", Plugin_info.logtag);
		return(FALSE);
	}
	else if(*interfaceVersion != ENGINE_INTERFACE_VERSION) {
		UTIL_LogPrintf("%s: GetEngineFunctions version mismatch; requested=%d ours=%d", Plugin_info.logtag, *interfaceVersion, ENGINE_INTERFACE_VERSION);
		// Tell metamod what version we had, so it can figure out who is out of date.
		*interfaceVersion = ENGINE_INTERFACE_VERSION;
		return(FALSE);
	}
	memcpy(pengfuncsFromEngine, &meta_engfuncs, sizeof(enginefuncs_t));
	return TRUE;
}
